/******************************************************************************

	xn_xx.c

	ꥢݡ̿ 

				           (C) 2005.2 Suwa-Koubou
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <termio.h>
#include <errno.h>


/*============================================================================
	Хѿ
=============================================================================*/

static char RsDevice[256] = "/dev/modem"; /* xn_xx serial device port */
static struct termios Pmode, Omode;    	/* device control string */
static int XNfd = -1;			/* device id */
static int TimeUp;


/*============================================================================
	ؿץȥ
=============================================================================*/

void	xn_device(char *device);
int	xn_open(void);
void	xn_close(void);
void	xn_flush( void );
int	xn_get_status(unsigned int *status);
int	xn_set_status(unsigned int *status);
int	xn_set_dtr(int sw);
int	xn_get_cd(void);
int	xn_putc(int ch);
int	xn_puts(char *s, int len);
int	xn_sputs(char *s);
int	xn_getc(void);
int	xn_getc_nb(void);
int	xn_getc_timer(int time_out);
int	xn_rcv_ready(void);
int	xn_gets(char *buff, int len);
void	xn_timer_set(int time_value);
void	xn_timer_reset(void);
int	xn_timer_check(void);
int	xn_gets_timer(char *buff, int len, int time_out);
int	xn_sgets_timer(char *buff, int cp, int time_out);
int	xn_ptrn_gets(char *ptrn[], char *buf, int time_out);
static	void	timer(int sig);


/*============================================================================
	³ǥХ
=============================================================================*/

void	xn_device(char *device)
{
	strcpy(RsDevice, device);
}


/*============================================================================
	ꥢǥХץ
=============================================================================*/

int	xn_open(void)
{
	if ((XNfd = open(RsDevice, O_RDWR | O_NOCTTY | O_SYNC /* | O_NDELAY  */)) < 0){
		return -1;
	}

	tcgetattr( XNfd, &Omode );
	Pmode = Omode;
	
	bzero(&Pmode, sizeof(Pmode));

	Pmode.c_cflag |= B115200;
	Pmode.c_cflag |= CS8 | CREAD ;
	Pmode.c_cflag |= CRTSCTS;
	Pmode.c_cflag |= HUPCL;
	Pmode.c_iflag |= IGNBRK | IGNPAR ; 

	if(tcsetattr( XNfd, TCSANOW, &Pmode) == -1){
		return -1;
	}

	if(tcflush( XNfd, TCIFLUSH ) == -1){
		xn_close();
		return -1;
	}

	xn_timer_reset();

	return 0;

}


/*============================================================================
	ꥢǥХ
=============================================================================*/

void	xn_close(void)
{
	if(XNfd != -1){
		tcsetattr( XNfd, TCSANOW, &Omode);
		close( XNfd );
	}

	XNfd = -1;
}


/*============================================================================
	Хåեեå
=============================================================================*/

void	xn_flush( void )
{
	int c;

	if(XNfd == -1)
		return;
	
	tcflush( XNfd, TCIFLUSH );

}


/*============================================================================
	ξ
=============================================================================*/

int	xn_get_status(unsigned int *status)
{

	if(XNfd == -1) return -1;

	if(ioctl(XNfd, TIOCMGET, status) == -1)
		return -1;
	return 0;

}


/*============================================================================
	ãĤξ
=============================================================================*/

int	xn_get_cd(void)
{
	unsigned int status;

	if(xn_get_status(&status) == -1) return 0;

	if(status & TIOCM_CAR)
		return 1;
	else
		return 0;

}


/*============================================================================
	ꤹ
=============================================================================*/

int	xn_set_status(unsigned int *status)
{

	if(XNfd == -1) return -1;

	if(ioctl(XNfd, TIOCMSET, status) == -1)
		return -1;
	return 0;

}


/*============================================================================
	ģԣҤ򥪥󥪥դ
	sw 0 ʤ饪0ʤ饪դˤ
=============================================================================*/

int	xn_set_dtr(int sw)
{
	unsigned int status;

	if(xn_get_status(&status) == -1) return -1;
	if(sw){
		status |= TIOCM_DTR;
	}else{
		status &= ~TIOCM_DTR;
	}

	if(xn_set_status(&status) == -1) return -1;

	return 0;
}



/*============================================================================
	ʸ
	ʤ飱Ԥʤݣ֤
=============================================================================*/

int	xn_snd_ready(void)
{
	fd_set w_bit;
	struct timeval tv;
	int    n;


	/* fidꥢ */
	FD_ZERO( &w_bit );

	/* XN-xx ̿ݡidå */		
	FD_SET( XNfd, &w_bit );

	/* Ԥ֥å */
	tv.tv_sec = 10;
	tv.tv_usec = 500000L; /* 0.5 Sec */

	/* Ԥ */
	if((n = select(FD_SETSIZE, NULL, &w_bit, NULL, &tv)) == -1){
		if(errno == EINTR){
			return 0;
		}
	}

	if(n == 0) return 0;

	if( FD_ISSET(XNfd, &w_bit)){
		return 1;
	}
	
	return 0;

}

int	xn_putc(int ch)
{
	char c;

	c = (ch & 0xff);
	
	while(xn_snd_ready() == 0)
		;
	
	if(write(XNfd, &c, 1) != 1){
		return -1;
	}

	return 1;

}


/*============================================================================
	ĹʸʥХʥϣˡ
	ʤʸ(=len)֤
	Ԥʤ-1֤
=============================================================================*/

int	xn_puts(char *s, int len)
{
	while(xn_snd_ready() == 0)
		;

	return write(XNfd, s, len);


/****
	int	count;


	for(count = 0; count < len; count++, s++){
		if(xn_putc(*s) != 1)
			return -1;
	}
	return count;
*****/
}

int	xn_sputs(char *s)
{
	return xn_puts(s, strlen(s));
}


/*============================================================================
	ʸ(none block mode)
	ʸʤСݣФʸ֤
=============================================================================*/

int	xn_getc_nb(void)
{
	char	c;

	/*
	 * ʸ̵ľ -1 
	 */
	if(read(XNfd, &c, 1) < 1)
		return(-1);

	return((int)c & 0xff);
}

/*============================================================================
	ʸ
	ʸʤмޤǤޤġ
=============================================================================*/

int	xn_getc(void)
{
	fd_set r_bit;
	int    c;


	/* fidꥢ */
	FD_ZERO( &r_bit );

	/* XN-xx ̿ݡidå */		
	FD_SET( XNfd, &r_bit );

	/* ʸԤ */
	if(select(FD_SETSIZE, &r_bit, NULL, NULL, NULL) == -1){
		if(errno == EINTR){
			return -1;	/* ॢȯ */
		}
	}

	/* ʸꡩ */
	if( FD_ISSET(XNfd, &r_bit)){
		if(read(XNfd, &c, 1) != 1){
			return -1;
		}
		return ((int)c & 0xff);
	}

	return -1;

}


/*============================================================================
	ʸ
	ʸʤ time_out ǻꤷÿ
	ޤǤޤġǤʤ -1 ֤
=============================================================================*/

int	xn_getc_timer(int time_out)
{
	fd_set r_bit;
	struct timeval tv;
	int    c, n;


	/* fidꥢ */
	FD_ZERO( &r_bit );

	/* XN-xx ̿ݡidå */		
	FD_SET( XNfd, &r_bit );

	/* ޡå */
	tv.tv_usec = 0;
	tv.tv_sec = time_out;

	/* ʸԤ */
	if((n = select(FD_SETSIZE, &r_bit, NULL, NULL, &tv)) == -1){
		if(errno == EINTR){
			return -1;	/* ॢȯ */
		}
	}

	if(n == 0) return -1;

	/* ʸꡩ */
	if( FD_ISSET(XNfd, &r_bit)){
		if(read(XNfd, &c, 1) != 1){
			return -1;
		}
		return ((int)c & 0xff);
	}

	return -1;

}


/*============================================================================
	ʸ뤫ǧ롣ʤС500msec ޤ
	ԤԤɤ߽Фʸ¸ߤ 1 , 
	 0 ֤
=============================================================================*/

int	xn_rcv_ready(void)
{
	fd_set r_bit;
	struct timeval tv;
	int    n;


	/* fidꥢ */
	FD_ZERO( &r_bit );

	/* XN-xx ̿ݡidå */		
	FD_SET( XNfd, &r_bit );

	/* Ԥ֥å */
	tv.tv_sec = 0;
	tv.tv_usec = 500000L; /* 0.5 Sec */

	/* ʸԤ */
	if((n = select(FD_SETSIZE, &r_bit, NULL, NULL, &tv)) == -1){
		if(errno == EINTR){
			return 0;
		}
	}

	if(n == 0) return 0;

	if( FD_ISSET(XNfd, &r_bit)){
		return 1;
	}
	
	return 0;

}


/*============================================================================
	ĹʸʥХʥͭ
	褿ʸ֤
=============================================================================*/

int	xn_gets(char *buff, int len)
{
	int	c;	
	int	count;


	/*
	 * ʸ̵ʤޤǡޤϻʸޤɤ³
	 */
	count = 0;
	while(count > len){
		if((c = xn_getc_nb()) == -1){
			break;
		}else{
			buff[count++] = c;
		}
	}

	return count;
}


/*=============================================================================
	ޡ
	ƻѤȤƣܤΥޡ
=============================================================================*/

static
void	timer(int sig)
{
	TimeUp = 1;
	signal(SIGALRM, timer);
}


void	xn_timer_set(int time_value)
{
	signal(SIGALRM, timer);
	TimeUp = 0;
	alarm(time_value);
}


void	xn_timer_reset(void)
{
	alarm(0);
	TimeUp = 0;
}

int	xn_timer_check(void)
{
	return TimeUp;
}


/*============================================================================
	ĹʸʥХʥͭ
	褿ʸ֤
	ʸꤷĹʤꤷ֤ޤ
Ԥ
=============================================================================*/

int	xn_gets_timer(char *buff, int len, int time_out)
{
	int	c;	
	int	count;

	xn_timer_set(time_out);

	count = 0;
	while(count < len && TimeUp == 0){
		if((c = xn_getc()) != -1)
			buff[count++] = c;
	}

	xn_timer_reset();

	return count;
}


/*============================================================================
	ʸиޤǤʸʥХʥͭ
	褿ʸ֤
	ʸиޤǻꤷּԤ
	 time_out ñ̤äȤ
	ॢȻϡ-1֤
	()1000ʸʾϼʤ褦ˤ
=============================================================================*/

int	xn_sgets_timer(char *buff, int cp, int time_out)
{
	int	c;	
	int	count;
	xn_timer_set(time_out);

	count = 0;

	do{
		if( (c = xn_getc()) != -1){
			buff[count++] = c;
		}

	}while( c != cp && TimeUp == 0 && count < 1000);

	buff[count] = '\0'; /* set EOS (null char) */


	if(TimeUp){
		TimeUp = 0;
		return -1;
	}

	if(TimeUp == 0){
		alarm(0);
	}

	if(count >= 1000){
		return -1;
	}

	return count;
}

/*=============================================================================
	char *ptrn[] ǼʸμԤԤ
	time_out ǻꤹÿλԤԤptrn ǻ
	뤤ʸʤäˤ -1 ֤
	ǤϡʸǤȤptrn Υ
	ǥå֤
=============================================================================*/

int	xn_ptrn_gets(char *ptrn[], char *buff, int time_out)
{
	int	c, p;
	int	count;

	xn_timer_set(time_out);

	count = 0;
	buff[0] = 0;
	while(TimeUp == 0){
		if((c = xn_getc()) != -1){
			buff[count++] = c;
			buff[count] = '\0'; /* set EOS(null) */
 printf("%s\n", buff);
			for(p = 0; ptrn[p] != NULL; p++){
				if(strstr(buff, ptrn[p]) != NULL){
					xn_timer_reset();
					return p;
				}
			}
		}
	}

	xn_timer_reset();

	return -1;
}

/**** End of xn_xx.c *********************************************************/
